<template>
  <div id="app">
    <div class="secret-box">
      <div class="header">
        <div id="tab-add" class="item" v-bind:class="{ active: activeTab === 'tab-add' }" @click="changeTab">
          Create
        </div>
        <div id="tab-get" class="item" v-bind:class="{ active: activeTab === 'tab-get' }" @click="changeTab">
          Unlock
        </div>
      </div>

      <div class="content-container">
        <div class="form-container">
          <component v-bind:is="activeTab" />
        </div>

        <div class="hash-container">
          <Hash v-for="item in encryptedHashes" :key="item.hash" :hash="item" />
          <p v-if="!encryptedHashes.length">No hash in this session</p>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  import Vue from 'vue';
  import { mapState, mapMutations } from 'vuex';
  import AddSecretContainer from './containers/AddSecretContainer';
  import GetSecretContainer from './containers/GetSecretContainer';
  import Hash from './components/Hash';

  Vue.component("tab-add", AddSecretContainer);
  Vue.component("tab-get", GetSecretContainer);

  export default {
    name: 'App',
    components: { AddSecretContainer, GetSecretContainer, Hash },
    data () {
      return { activeTab: 'tab-add' };
    },
    computed: mapState({
      encryptedHashes: state => state.encryptedHashes,
      decryptedHash: state => state.decryptedHash
    }),
    methods: {
      ...mapMutations(['setError']),
      changeTab (evt) {
        this.activeTab = evt.target.id;
        this.setError({ error: null });
      }
    }
  }
</script>

<style lang="scss">
  body {
    margin: 0;
    p {
      margin: 0;
    }

    #app {
      font-family: Avenir, Helvetica, Arial, sans-serif;
      -webkit-font-smoothing: antialiased;
      -moz-osx-font-smoothing: grayscale;
      color: $text-dark;

      .secret-box {
        position: relative;
        width: 100%;
        background-color: $white;

        .header {
          position: absolute;
          top: 0;
          width: 100%;
          height: 50px;
          display: flex;
          flex-direction: row;
          border-top-left-radius: 5px;
          border-top-right-radius: 5px;
          border-bottom: 2px solid $blue;

          .item {
            width: 50%;
            display: flex;
            align-items: center;
            justify-content: center;
            font-size: 1.2rem;
            font-weight: 500;
            cursor: pointer;
            
            &:first-child {
              border-right: 2px solid $blue;
            }

            &.active {
              color: #fff;
              background-color: $blue;
            }
          }
        }

        .content-container {
          padding: 5rem 1.5rem 1rem 1.5rem;
          display: flex;
          flex-direction: row;

          .form-container,
          .hash-container {
            width: 50%;
            margin-right: 1rem;
          }

          .hash-container {
            text-align: center;
          }

          @media (max-width: 700px) {
            flex-direction: column;
            
            .form-container,
            .hash-container {
              margin: 0;
              width: 100%;
            }
          }
        }
      }
    }
  }
</style>
